package org.foo.commands;

import java.util.concurrent.TimeUnit;

import javax.cache.Cache;
import javax.cache.annotation.CacheKey;
import javax.cache.configuration.MutableConfiguration;
import javax.cache.expiry.CreatedExpiryPolicy;
import javax.cache.expiry.Duration;
import javax.inject.Inject;

import org.jboss.forge.addon.infinispan.CacheManagerFactory;
import org.jboss.forge.addon.infinispan.MyInterceptorBinding;
import org.jboss.forge.addon.ui.command.AbstractUICommand;
import org.jboss.forge.addon.ui.context.UIContext;
import org.jboss.forge.addon.ui.context.UIExecutionContext;
import org.jboss.forge.addon.ui.metadata.UICommandMetadata;
import org.jboss.forge.addon.ui.result.Result;
import org.jboss.forge.addon.ui.result.Results;
import org.jboss.forge.addon.ui.util.Metadata;

public class HelloCommand extends AbstractUICommand
{
   @Inject
   private CacheManagerFactory cacheManagerFactory;

   @Override
   public UICommandMetadata getMetadata(UIContext context)
   {
      return Metadata.forCommand(HelloCommand.class).name("x");
   }

   @Override
   public Result execute(UIExecutionContext context) throws Exception
   {
      Cache<String, String> cache = cacheManagerFactory.createOrGetCache("default",
               () -> new MutableConfiguration<String, String>()
                        .setExpiryPolicyFactory(
                                 () -> new CreatedExpiryPolicy(new Duration(TimeUnit.SECONDS, 5)))
                        .setStoreByValue(false));
      // if (!cache.containsKey("foo"))
      // {
      // cache.put("foo", "value" + System.currentTimeMillis());
      // }

      return Results.success("Cached Value: " + teste("foo"));
   }

   @MyInterceptorBinding
   // @CacheResult(cacheName = "default")
   public String teste(@CacheKey String key)
   {
      System.out.println("******* TESTE");
      return "key" + System.currentTimeMillis();
   }

}